org.springframework.cache

## Interface Cache

- All Known Implementing Classes:
    AbstractValueAdaptingCache, CaffeineCache, ConcurrentMapCache, EhCacheCache, JCacheCache, NoOpCache, TransactionAwareCacheDecorator

      public interface Cache

  Interface that defines common cache operations.

  Serves as an SPI for Spring's annotation-based caching model (`Cacheable` and co) as well as an API for direct usage in applications.

  Note: Due to the generic use of caching, it is recommended that implementations allow storage of `null` values (for example to cache methods that return `null`).

  Since:
    3.1
  Author:
    Costin Leau, Juergen Hoeller, Stephane Nicoll
  See Also:
    `CacheManager`, `Cacheable`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `Cache.ValueRetrievalException` Wrapper exception to be thrown from `get(Object, Callable)` in case of the value loader callback failing with an exception.
    `static interface` | `Cache.ValueWrapper` A (wrapper) object representing a cache value.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` Clear the cache through removing all mappings.
    `void` | `evict(Object key)` Evict the mapping for this key from this cache if it is present.
    `default boolean` | `evictIfPresent(Object key)` Evict the mapping for this key from this cache if it is present, expecting the key to be immediately invisible for subsequent lookups.
    `Cache.ValueWrapper` | `get(Object key)` Return the value to which this cache maps the specified key.
    `<T> T` | `get(Object key, Callable<T> valueLoader)` Return the value to which this cache maps the specified key, obtaining that value from `valueLoader` if necessary.
    `<T> T` | `get(Object key, Class<T> type)` Return the value to which this cache maps the specified key, generically specifying a type that return value will be cast to.
    `String` | `getName()` Return the cache name.
    `Object` | `getNativeCache()` Return the underlying native cache provider.
    `default boolean` | `invalidate()` Invalidate the cache through removing all mappings, expecting all entries to be immediately invisible for subsequent lookups.
    `void` | `put(Object key, Object value)` Associate the specified value with the specified key in this cache.
    `default Cache.ValueWrapper` | `putIfAbsent(Object key, Object value)` Atomically associate the specified value with the specified key in this cache if it is not set already.

- - ### Method Detail

    - #### getName

          String getName()

      Return the cache name.

    - #### getNativeCache

          Object getNativeCache()

      Return the underlying native cache provider.

    - #### get

          @Nullable
          Cache.ValueWrapper get(Object key)

      Return the value to which this cache maps the specified key.

      Returns `null` if the cache contains no mapping for this key; otherwise, the cached value (which may be `null` itself) will be returned in a `Cache.ValueWrapper`.

      Parameters:
        `key` - the key whose associated value is to be returned
      Returns:
        the value to which this cache maps the specified key, contained within a `Cache.ValueWrapper` which may also hold a cached `null` value. A straight `null` being returned means that the cache contains no mapping for this key.
      See Also:
        `get(Object, Class)`, `get(Object, Callable)`

    - #### get

          @Nullable
          <T> T get(Object key,
                              @Nullable
                              Class<T> type)

      Return the value to which this cache maps the specified key, generically specifying a type that return value will be cast to.

      Note: This variant of `get` does not allow for differentiating between a cached `null` value and no cache entry found at all. Use the standard `get(Object)` variant for that purpose instead.

      Parameters:
        `key` - the key whose associated value is to be returned
        `type` - the required type of the returned value (may be `null` to bypass a type check; in case of a `null` value found in the cache, the specified type is irrelevant)
      Returns:
        the value to which this cache maps the specified key (which may be `null` itself), or also `null` if the cache contains no mapping for this key
      Throws:
        `IllegalStateException` - if a cache entry has been found but failed to match the specified type
      Since:
        4.0
      See Also:
        `get(Object)`

    - #### get

          @Nullable
          <T> T get(Object key,
                              Callable<T> valueLoader)

      Return the value to which this cache maps the specified key, obtaining that value from `valueLoader` if necessary. This method provides a simple substitute for the conventional "if cached, return; otherwise create, cache and return" pattern.

      If possible, implementations should ensure that the loading operation is synchronized so that the specified `valueLoader` is only called once in case of concurrent access on the same key.

      If the `valueLoader` throws an exception, it is wrapped in a `Cache.ValueRetrievalException`

      Parameters:
        `key` - the key whose associated value is to be returned
      Returns:
        the value to which this cache maps the specified key
      Throws:
        `Cache.ValueRetrievalException` - if the `valueLoader` throws an exception
      Since:
        4.3
      See Also:
        `get(Object)`

    - #### put

          void put(Object key,
                   @Nullable
                   Object value)

      Associate the specified value with the specified key in this cache.

      If the cache previously contained a mapping for this key, the old value is replaced by the specified value.

      Actual registration may be performed in an asynchronous or deferred fashion, with subsequent lookups possibly not seeing the entry yet. This may for example be the case with transactional cache decorators. Use `putIfAbsent(java.lang.Object, java.lang.Object)` for guaranteed immediate registration.

      Parameters:
        `key` - the key with which the specified value is to be associated
        `value` - the value to be associated with the specified key
      See Also:
        `putIfAbsent(Object, Object)`

    - #### putIfAbsent

          @Nullable
          default Cache.ValueWrapper putIfAbsent(Object key,
                                                           @Nullable
                                                           Object value)

      Atomically associate the specified value with the specified key in this cache if it is not set already.

      This is equivalent to:

           ValueWrapper existingValue = cache.get(key);
           if (existingValue == null) {
               cache.put(key, value);
           }
           return existingValue;

      except that the action is performed atomically. While all out-of-the-box `CacheManager` implementations are able to perform the put atomically, the operation may also be implemented in two steps, e.g. with a check for presence and a subsequent put, in a non-atomic way. Check the documentation of the native cache implementation that you are using for more details.

      The default implementation delegates to `get(Object)` and `put(Object, Object)` along the lines of the code snippet above.

      Parameters:
        `key` - the key with which the specified value is to be associated
        `value` - the value to be associated with the specified key
      Returns:
        the value to which this cache maps the specified key (which may be `null` itself), or also `null` if the cache did not contain any mapping for that key prior to this call. Returning `null` is therefore an indicator that the given `value` has been associated with the key.
      Since:
        4.1
      See Also:
        `put(Object, Object)`

    - #### evict

          void evict(Object key)

      Evict the mapping for this key from this cache if it is present.

      Actual eviction may be performed in an asynchronous or deferred fashion, with subsequent lookups possibly still seeing the entry. This may for example be the case with transactional cache decorators. Use `evictIfPresent(java.lang.Object)` for guaranteed immediate removal.

      Parameters:
        `key` - the key whose mapping is to be removed from the cache
      See Also:
        `evictIfPresent(Object)`

    - #### evictIfPresent

          default boolean evictIfPresent(Object key)

      Evict the mapping for this key from this cache if it is present, expecting the key to be immediately invisible for subsequent lookups.

      The default implementation delegates to `evict(Object)`, returning `false` for not-determined prior presence of the key. Cache providers and in particular cache decorators are encouraged to perform immediate eviction if possible (e.g. in case of generally deferred cache operations within a transaction) and to reliably determine prior presence of the given key.

      Parameters:
        `key` - the key whose mapping is to be removed from the cache
      Returns:
        `true` if the cache was known to have a mapping for this key before, `false` if it did not (or if prior presence could not be determined)
      Since:
        5.2
      See Also:
        `evict(Object)`

    - #### clear

          void clear()

      Clear the cache through removing all mappings.

      Actual clearing may be performed in an asynchronous or deferred fashion, with subsequent lookups possibly still seeing the entries. This may for example be the case with transactional cache decorators. Use `invalidate()` for guaranteed immediate removal of entries.

      See Also:
        `invalidate()`

    - #### invalidate

          default boolean invalidate()

      Invalidate the cache through removing all mappings, expecting all entries to be immediately invisible for subsequent lookups.
      Returns:
        `true` if the cache was known to have mappings before, `false` if it did not (or if prior presence of entries could not be determined)
      Since:
        5.2
      See Also:
        `clear()`